﻿Imports System.IO

Public Class Form1
    ' Start in the source directory.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim dir_info As New DirectoryInfo( _
            Path.Combine(Application.StartupPath, "..\..\"))
        txtDirectory.Text = dir_info.FullName
    End Sub

    ' Search for the files.
    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
        Dim filenames As List(Of String) = FindFiles( _
            txtDirectory.Text, txtPatterns.Text, chkSearchSubdirectories.Checked)
        lstFiles.Items.Clear()
        For Each filename As String In filenames
            lstFiles.Items.Add(filename)
        Next filename
    End Sub

    ' Search for files matching the patterns.
    Private Function FindFiles(ByVal dir_name As String, ByVal patterns As String, ByVal search_subdirectories As Boolean) As List(Of String)
        ' Make the result list.
        Dim files As New List(Of String)()

        ' Get the patterns.
        Dim pattern_array() As String = patterns.Split(";"c)

        ' Search.
        Dim search_option As SearchOption = SearchOption.TopDirectoryOnly
        If search_subdirectories Then search_option = SearchOption.AllDirectories
        For Each pattern As String In pattern_array
            For Each filename As String In Directory.GetFiles(dir_name, pattern, search_option)
                If Not files.Contains(filename) Then files.Add(filename)
            Next filename
        Next pattern

        ' Sort.
        files.Sort()

        ' Return the result.
        Return files
    End Function

    ' Let the user select a directory.
    Private Sub btnPickDirectory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPickDirectory.Click
        fbdDirectory.SelectedPath = txtDirectory.Text
        If (fbdDirectory.ShowDialog() = DialogResult.OK) Then
            txtDirectory.Text = fbdDirectory.SelectedPath
        End If
    End Sub
End Class
